<div style="width: 100%; clear: both; margin-top: 5px; display: none;" id="aba_coluna_calculada">
		<div style="float: left; padding: 5px; background: #f2f2f2; height: 110px;">
			<label>Nome</label>
			<br>
			<input class="form" id="nome_coluna_calc"  style="width: 150px; "></input>
		</div>
		<div style="float: left; padding: 5px; background: #f2f2f2; margin-left: 10px; height: 110px;">
			<label>Colunas de valores</label>
			<br>
			<select class="form" id="colunas_para_calc" onchange="setColunaCalc(this)" placeholder="Tipo" multiple   style="width: 150px; ">
				
			</select>
		</div>
		<div style="float: left; padding: 5px; background: #f2f2f2; margin-left: 10px; height: 110px;">
			<label>Oparações</label>
			<br>
			<select class="form" id="operacoes_para_calc" onchange="setColunaCalc(this)" placeholder="Tipo" multiple   style="width: 150px;">
				<option value="-">-</option>
				<option value="+">+</option>
				<option value="*">*</option>
				<option value="/">/</option>
				<option value="(">(</option>
				<option value=")">)</option>
				<option value="CASE">CASE</option>
				<option value="WHEN">WHEN</option>
				<option value="THEN">THEN</option>
				<option value="ELSE">ELSE</option>
				<option value="END">END</option>
				<option value=">">></option>
				<option value="<"><</option>
				<option value=">=">>=</option>
				<option value="<="><=</option>
				<option value="=">=</option>
				<option value="MIN">MIN</option>
				<option value="MAX">MAX</option>
				<option value="AVG">AVG</option>
			</select>
		</div>
		<div style="float: left; padding: 5px; background: #f2f2f2; margin-left: 10px; height: 110px;">
			<label>Valor</label>
			<br>
			<input type="number" class="form" id="valor_para_calc"  style="width: 150px; "></input>
			<br>
			<button class="btnSuccess btnSn" style="float: left;" onclick="setColunaCalc($('#valor_para_calc'))">Add valor</button>
			
		</div>
		<!--<div style="float: left; padding: 5px; background: #f2f2f2; height: 110px; margin-left: 10px;">
			<label></label>
			<br>
			<button class="btnSuccess btnSn" style="float: left;" onclick="incluir_coluna_calculada()">Incluir coluna</button>
		</div>-->
		<button class="btnSuccess btnSn" style="float: left;" onclick="incluir_coluna_calculada()">Incluir/Alterar coluna</button>
	
	<br>
	<label style="width: 100%; clear: both;">Regras (Click nas colunas e operações acima para formar a conula) se(condição;verdadeiro;falso)</label><br>
	<select class="form" id="colunas_calculada"   multiple style="width: 100%">
		
	</select>
	<label>Colunas</label><Br>
	<div style="width: 100%; ">
		<table id="tabela" border="1" class="tableAnalise" style="width: 100%;" >
			<thead>
				<tr><td></td><td>Nome</td><td>Regras</td></tr>
			</thead>	
			<tbody id="linhaColuna">
				
			</tbody>
		</table>
	</div>
	</div>
	
	<script>
		seletorSendoAlterado = null;
		colunaSendoAlterado = null;
		//colunas calculada
		$("#colunas_calculada").select2({ width: '100%' });
		//abaixo codigo para colocar na sequencia de clique
		$("#colunas_calculada").on("select2:select", function (evt) {var element = evt.params.data.element; var $element = $(element); $element.detach(); $(this).append($element); $(this).trigger("change");});
		function abrirAbaColunaCalculada()
		{
			if($("#aba_coluna_calculada").css("display") == "none")
			{
				$("#aba_coluna_calculada").css("display", "block");
				for(i =0; i < colunas.length; i++)
				{
					if(colunas[i].tipo_dado == "int" || colunas[i].tipo_dado == "float")
					{
						selected = false;
						if(! $("#colunas_para_calc").html().includes(colunas[i].nome))
						{
							$("#colunas_para_calc").append($('<option>', {
								value: colunas[i].nome,
								text: colunas[i].nome,
								"selected": selected
							}));
						}
						//validar se ja é calculada
						if(colunas[i].nome.includes("calc:") && ! $("#linhaColuna").html().includes(colunas[i].nome))
						{
							hrmlLinha = "<tr>";
							hrmlLinha += "<td><a href='javaScript:void(0)' onclick='setRemover(\""+colunas[i].nome+"\", this)'><i class=\"fa fa-trash\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a>&nbsp;-&nbsp;<a href='javaScript:void(0)' onclick='setAlterar(\""+colunas[i].nome+"\", this)'><i class=\"fa fa-pencil\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a></td>";
							hrmlLinha += "<td>"+colunas[i].nome+"</td><td>"+colunas[i].regra_calculada+"</td>";
							hrmlLinha += "</tr>";
							$("#linhaColuna").append(hrmlLinha);
						}
						
					}
				}
			}
			else
			{
				$("#aba_coluna_calculada").css("display", "none");
			}
		}
		function setColunaCalc(seletor)
		{
			if($(seletor).val() != "" && $(seletor).val() != null)
			{
				if($(seletor).attr("id") == "colunas_para_calc" && ! $(seletor).val().includes("`"))
				{
					$("#colunas_calculada").append("<option value='`"+$(seletor).val()+"`' selected= 'selected'>`"+$(seletor).val()+"`</option>").change();
				}
				else
				{
					$("#colunas_calculada").append("<option value='"+$(seletor).val()+"' selected= 'selected'>"+$(seletor).val()+"</option>").change();
				}
				$("#"+$(seletor).attr("id")).val("").change();
			}
		}
		function incluir_coluna_calculada()
		{
			if(colunaSendoAlterado != null)
			{
				for(i =0; i < colunas.length; i++)
				{
					if(colunas[i].nome == colunaSendoAlterado)
					{
						colunas[i].regra_calculada = $("#colunas_calculada").val()+"";
						$(seletorSendoAlterado).parent().parent().html("<td><a href='javaScript:void(0)' onclick='setRemover(\""+colunaSendoAlterado+"\", this)'><i class=\"fa fa-trash\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a>&nbsp;-&nbsp;<a href='javaScript:void(0)' onclick='setAlterar(\""+colunaSendoAlterado+"\", this)'><i class=\"fa fa-pencil\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a></td><td>"+colunaSendoAlterado+"</td><td>"+$("#colunas_calculada").val()+"</td>");
					}
				}
				$("#colunas_calculada").val("").change();
				$("#nome_coluna_calc").val("");
				$("#nome_coluna_calc").removeAttr("readonly");
				seletorSendoAlterado = null;
				colunaSendoAlterado = null;
			}
			else
			{
				if($("#nome_coluna_calc").val().trim() == "")
				{
					alert("Informe o nome!");
				}
				else if($("#colunas_calculada").val() == null || ($("#colunas_calculada").val()+"").trim() == "")
				{
					alert("Sem regras!");
				}
				else
				{
					if(! $(nome_coluna_calc).val().includes("calc:"))
					{
						$("#linhaColuna").append("<tr><td><a href='javaScript:void(0)' onclick='setRemover(\""+$("#nome_coluna_calc").val()+"\", this)'><i class=\"fa fa-trash\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a>&nbsp;-&nbsp;<a href='javaScript:void(0)' onclick='setAlterar(\""+$("#nome_coluna_calc").val()+"\", this)'><i class=\"fa fa-pencil\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a></td><td>calc:"+$("#nome_coluna_calc").val()+"</td><td>"+$("#colunas_calculada").val()+"</td></tr>");
					}
					else
					{
						$("#linhaColuna").append("<tr><td><a href='javaScript:void(0)' onclick='setRemover(\""+$("#nome_coluna_calc").val()+"\", this)'><i class=\"fa fa-trash\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a>&nbsp;-&nbsp;<a href='javaScript:void(0)' onclick='setAlterar(\""+$("#nome_coluna_calc").val()+"\", this)'><i class=\"fa fa-pencil\" aria-hidden=\"true\" style=\"color: #38597a; font-size: 13px;\"></i></a></td><td>"+$("#nome_coluna_calc").val()+"</td><td>"+$("#colunas_calculada").val()+"</td></tr>");
					}
					if($("#select_colunas_valores_vertical") != null)
					{
						$("#select_colunas_valores_vertical").append("<option value='calc:"+$("#nome_coluna_calc").val()+"' >"+$("#nome_coluna_calc").val()+"</option>").change();
					}
					coluna = {};
					coluna.nome = $(nome_coluna_calc).val();
					if(! $(nome_coluna_calc).val().includes("calc:"))
					{
						coluna.nome = "calc:"+$(nome_coluna_calc).val();
					}
					coluna.apelido = $(nome_coluna_calc).val();
					coluna.tipo_dado = 'float';
					coluna.codigo = '';
					coluna.oculto = false;
					coluna.mascara = '';
					coluna.cod_agregacao = '';
					coluna.id_tipo_dado = '3';
					coluna.regra_calculada = $("#colunas_calculada").val()+"";
					colunas.push(coluna);
					$("#colunas_calculada").val("").change();
					$("#nome_coluna_calc").val("");
					seletorSendoAlterado = null;
					colunaSendoAlterado = null;
				}
			}
		}
		function setRemover(nome_colun, seletor)
		{
			if($("#select_colunas_valores_vertical").val() != null && $("#select_colunas_valores_vertical").val().includes(nome_colun))
			{
				alert("Retire a coluna dos valores!");
			}
			else if($("#select_colunas_total_vertical").val() != null && $("#select_colunas_total_vertical").val().includes(nome_colun))
			{
				alert("Retire a coluna do tatalizador soma!");
			}
			else if($("#select_colunas_media_vertical").val() != null && $("#select_colunas_media_vertical").val().includes(nome_colun))
			{
				alert("Retire a coluna do tatalizador média!");
			}
			else
			{
				$(seletor).parent().parent().css("background", "red");
				for(i =0; i < colunas.length; i++)
				{
					if(colunas[i].nome == nome_colun)
					{
						colunas[i].remover = true;
					}
				}
			}
			seletorSendoAlterado = null;
			colunaSendoAlterado = null;
			$("#colunas_calculada").val("").change();
			$("#nome_coluna_calc").val("");
		}
		
		function setAlterar(nome_colun, seletor)
		{
			$("#colunas_calculada").val("").change();
			$("#nome_coluna_calc").val("");
			seletorSendoAlterado = seletor;
			colunaSendoAlterado = nome_colun;
			for(i =0; i < colunas.length; i++)
			{
				if(colunas[i].nome == nome_colun)
				{
					//alert(colunas[i].regra_calculada);
					//$("#colunas_calculada").val(colunas[i].regra_calculada).change();
					aRegra = colunas[i].regra_calculada.split(",");
					for(j =0; j < aRegra.length; j++)
					{
						$("#colunas_calculada").append("<option value='"+aRegra[j]+"' selected= 'selected'>"+aRegra[j]+"</option>").change();
					}
					$("#nome_coluna_calc").val(nome_colun);
					$("#nome_coluna_calc").attr("readonly", "readonly");
					
				}
			}
		}
		
				
	</script>